# This file is part of 'Cut The Crap (CTC)'
# Copyright 1999-2000 Constantinos A. Kotsokalis <ckotso@cs.ntua.gr>
#
# CTC is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# CTC is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with CTC; see the file COPYING. If not, write to the
# Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
#

import string

class acl:

	def __init__(self, errobj):
		self.allow_all = 1
		self.deny_all = 0
		self.list_allow = []
		self.list_deny = []
		self.errobj = errobj


	def add_allow(self, subnet):
		errobj = self.errobj

		if subnet in self.list_allow:
			errobj.eprint(subnet + " is already granted access!", None)
		elif subnet in self.list_deny:
			errobj.eprint("Can't have " + subnet + " in both allow and deny lists". None)
		else:
			self.list_allow.append(subnet)


	def add_deny(self, subnet):
		errobj = self.errobj

		if subnet in self.list_deny:
			errobj.eprint(subnet + " is already denied access!", None)
		elif subnet in self.list_allow:
			errobj.eprint("Can't have " + subnet + " in both allow and deny lists", None)
		else:
			self.list_deny.append(subnet)


	def all_allow(self):
		self.allow_all = 1
		self.deny_all = 0


	def all_deny(self):
		self.deny_all = 1
		self.allow_all = 0


	def is_allowed(self, IP):
		if self.deny_all:
			for subnet in self.list_allow:
				if string.find(IP, subnet) == 0:
					return 1
				else:
					continue
			return 0
		if self.allow_all:
			for subnet in self.list_deny:
				if string.find(IP, subnet) == 0:
					return 0
				else:
					continue
			return 1

