# This file is part of 'Cut The Crap (CTC)'
# Copyright 1999-2000 Constantinos A. Kotsokalis <ckotso@cs.ntua.gr>
#
# CTC is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# CTC is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with CTC; see the file COPYING. If not, write to the
# Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
#

import types
import sys

# Error reporting class
class error_object:

	# Print a message for the error that occured
	def eprint(self, str, msg):
		if type(msg) == types.StringType:
			err_str = str + msg
		else:
			try:
				err_str = str + msg[1]
			except:
				try:
					err_str = str + msg[0]
				except:
					err_str = str

		sys.stderr.write(err_str + "\n")
		
		return
	

	# Same as eprint but exit the application right after (used on
	# critical conditions)
	def eprint_exit(self, str, msg):
		self.eprint(str, msg)

		sys.exit(1)

